package com.gigaspaces;

import org.openspaces.core.GigaSpace;
import org.openspaces.core.GigaSpaceConfigurer;
import org.openspaces.core.space.UrlSpaceConfigurer;
import org.openspaces.events.adapter.SpaceDataEvent;
import org.openspaces.events.notify.SimpleNotifyContainerConfigurer;
import org.openspaces.events.notify.SimpleNotifyEventListenerContainer;

import com.j_spaces.core.IJSpace;

/**
 * Created by Yuvald on 11/08/2014.
 */
public class Main1 {

  // tested with gigaspaces-xap-premium-10.2.0-m2
  public static void main(final String[] args) {

    //IJSpace ispace = new UrlSpaceConfigurer("/./" + "mySpace")
    final IJSpace ispace = new UrlSpaceConfigurer("jini://localhost/*/" + "mySpace")
        //.lookupGroups("gigaspaces-10.2.1-XAPPremium-ga")
        // .lookupLocators("yuval-solaris10:4174")
        .space();
    final GigaSpace gigaSpace = new GigaSpaceConfigurer(ispace).clustered(true).gigaSpace();

    final SimpleNotifyEventListenerContainer notifyEventListenerContainer =
        new SimpleNotifyContainerConfigurer(gigaSpace).template(new MyData2())
        .eventListenerAnnotation(new Object()
        {
          @SpaceDataEvent
          public void eventHappened(final MyData2 data) {
            System.out.println("Got matching event! - " + data);
          }
        })
        //.durable(true)
        //.notifyAll(true)
        //.notifyUnmatched(true)
        //.fifo(false)
        //.replicateNotifyTemplate(true)
        //.triggerNotifyTemplate(true)
        //.batchSize(5)
        //.batchTime(100)
        .autoRenew(true)
        .notifyContainer();
    notifyEventListenerContainer.start();

    while(true){
      try {
        Thread.sleep(5000);
      }catch(final InterruptedException e){
        e.printStackTrace();
      }
    }
  }
}
