package com.gigaspaces;

import com.gigaspaces.events.DataEventSession;
import com.j_spaces.core.client.SQLQuery;
import org.openspaces.events.EventDriven;
import org.openspaces.events.EventTemplate;
import org.openspaces.events.TransactionalEvent;
import org.openspaces.events.adapter.SpaceDataEvent;
import org.openspaces.events.notify.Notify;
import org.openspaces.events.notify.NotifyBatch;
import org.openspaces.events.notify.NotifyType;
import org.openspaces.events.polling.Polling;

/**
 * Created by Yuvald on 11/08/2014.
 */

@TransactionalEvent
@Notify(gigaSpace="clusteredGigaSpace")
@NotifyType(write = true, update = true, take = true)
@EventDriven @Polling()
@NotifyBatch(size = 10, time = 5000, passArrayAsIs = true)
public class MySimpleListener {

    DataEventSession  session;

    public MySimpleListener(DataEventSession session) {
        this.session = session;
    }

    @EventTemplate // Marking a listener method with this annotation will result in its return value to be used as the template for the event container.
    SQLQuery<MyData1> unprocessedData() {
        SQLQuery<MyData1> template = new SQLQuery<MyData1>(MyData1.class, "processed = false");
        return template;
    }

    @SpaceDataEvent
    public MyData1 eventListener(MyData1 event) {
        System.out.println("data key = " + event.getKey());
        event.setProcessed(true);

        try {
            Thread.sleep(1000);
        }catch(Exception e){
            e.printStackTrace();
        }

        return event;
    }
}
